'
'  Auteur : Philippe Darnis
'
' Transforme des fichiers .imap pour les mettre dans la file d'envoi
'
'    Lancement : cscript /nologo renvoiMailsDifferes.vbs
'
'-----------------------------------------------------------------
' Les dossiers ci-dessous doivent exister et il faut mettre le nom de domaine correct dans FromEmptyField
'
FolderMails    = "C:\IWdata\mail\provisoire\"  rem dossier  crer des fichiers  traiter
FolderTmp      = "C:\IWdata\mail\provisoire\tmp"    rem dossier  crer des fichiers en cours de traitement
FolderTarget   = "C:\IWdata\mail\_outgoing\" rem dossier des messages en cours d'mission
FromEmptyField = "From: admin@domaine.com" rem adresse du from si celui-ci n'est pas renseign

	'
	' diffrentes expressions rgulires  tester
	'
	Set nomFichier     = new regexp
	nomFichier.Pattern = "^(.*\.)imap$"
	nomFichier.Global  = False	
	
	Set finEnTete     = new regexp
	finEnTete.Pattern = "^$"
	finEnTete.Global  = False
	
	Set ToField     = new regexp
	ToField.Pattern = "^To: "
	ToField.Global  = False	
	
	Set CcField     = new regexp
	CcField.Pattern = "^Cc: "
	CcField.Global  = False	
	
	Set FromField     = new regexp
	FromField.Pattern = "^From: "
	FromField.Global  = False
	
	Set endField     = new regexp
	endField.Pattern = "(^[^:]+: )|(^$)"
	endField.Global  = False
	
	Set endHeader     = new regexp
	Set emptyData     = endHeader
	endHeader.Pattern = "^$"
	endHeader.Global  = False
	
	Set doublePonctuation     = new regexp
	doublePonctuation.Pattern = "\s*[,;]+\s*"
	doublePonctuation.Global  = True
	
	Set ponctuationDebutFin     = new regexp
	ponctuationDebutFin.Pattern = "(^[,;\s]*)|([,;\s]*$)"
	ponctuationDebutFin.Global  = True

	Set objFSO = CreateObject("Scripting.FileSystemObject")
	Set folder = objFSO.GetFolder(FolderMails)
	Set files  = folder.Files
	'
	' liste des fichiers du dossier  traiter
	'
	For Each file in files
		nomImap  = file.Name
		fileImap = FolderMails & "\" & nomImap
	    
			nomTmp       = nomFichier.replace(nomImap,"$1tmp")
			fileTmp      = FolderTmp & "\" & nomTmp
			fileTmpFinal = FolderTarget & "\" & nomTmp
			'wscript.echo fileTmp
			'wscript.echo fileImap
			'wscript.echo fileTmpFinal
			'
			' on commence par chercher le champ To: ventuellement rparti sur plusieurs lignes
			' lorsqu'on le trouve, on le copie dans le fichier tmp
			'
			Set objFileImap  = objFSO.OpenTextFile (fileImap, 1)
			continuer = not objFileImap.AtEndOfStream
			toFound=false
			ccFound=false
			fromFound=false
			toFinished=false
			ccFinished=false
			fromFinished=false
			toNewField = ""
			fromNewField = ""
			Do while (continuer)
				strLine      = objFileImap.Readline
				toLine       = ToField.Test(strLine)
				ccLine       = CcField.Test(strLine)
				fromLine     = FromField.Test(strLine)
				emptyLine    = endHeader.Test(strLine)
				toFound      = toFound or toLine
				ccFound      = ccFound or ccLine or emptyLine
				fromFound    = fromFound or fromLine or emptyLine
				toFinished   = toFinished or (toFound and ((not toLine) and (endField.Test(strLine))))
				ccFinished   = ccFinished or (ccFound and ((not ccLine) and (endField.Test(strLine))))	
				fromFinished = fromFinished or (fromFound and ((not fromLine) and (endField.Test(strLine))))
				inToLines    = toFound and (not toFinished)
				inCcLines    = ccFound and (not ccFinished)
				inFtromLines = fromFound and (not fromFinished)
				continuer    = (not objFileImap.AtEndOfStream) and ((inToLines or (not toFound)) or (inCcLines or (not ccFound)) or (inFromLines or (not fromFound))) and (not emptyLine)
				if ((inToLines or inCcLines) and (not emptyLine)) Then
					if (inToLines) Then
						strLine = ToField.replace(strLine,"")
					End If
					if (inCcLines) Then
						strLine = CcField.replace(strLine,"")
					End If
					if (emptyData.Test(toNewField)) Then
						toNewField = strLine
					Else
						toNewField = toNewField & "|" & strLine
					End If
					'wscript.echo "toNewField: " & toNewField
				ElseIf (inFtromLines) Then
					if (emptyData.Test(fromNewField)) Then
						fromNewField = strLine
					Else
						fromNewField = fromNewField & vbCrLf & strLine
					End If
				End If
			Loop
			objFileImap.Close
			Set objFileImap = Nothing
			toNewField= ponctuationDebutFin.replace(doublePonctuation.replace(toNewField,","),"")
			if (not emptyData.Test(toNewField)) Then
				'
				' on insre des informations dans le fichier tmp
				'
				Set objFileTmp = objFSO.OpenTextFile (fileTmp, 2, true)
				objFileTmp.WriteLine "Host: 127.0.0.1"
				if (emptyData.Test(fromNewField)) Then
					objFileTmp.WriteLine FromEmptyField
				Else
					objFileTmp.WriteLine fromNewField
				End If
				addresses = Split(toNewField,"|",-1,1)
				For Each address in addresses
					'wscript.echo "To: " & address
					objFileTmp.WriteLine "To: " & address
				Next
				'
				' on recopie tout le contenu du fichier imap dans le fichier tmp
				'
				Set objFileImap  = objFSO.OpenTextFile (fileImap, 1)
				Do until (objFileImap.AtEndOfStream)
					strLine = objFileImap.Readline
					objFileTmp.WriteLine strLine
				Loop
				objFileImap.Close
				Set objFileImap = Nothing
				objFileTmp.Close
				Set objFileTmp = Nothing
				'
				' on dplace le fichier tmp gnr dans son dossier final (s'il existe, on le supprime)
				'
				If (objFSO.FileExists(fileTmpFinal)) Then
					Set objFileTmpDel = objFSO.GetFile(fileTmpFinal)
					objFileTmpDel.Delete()
				End If
				Set objFileTmp = objFSO.GetFile (fileTmp)	
				objFileTmp.Move (fileTmpFinal)
			End If
			'
			' on supprime le fichier 
			'
			Set objFileImap = objFSO.GetFile (fileImap)
			objFileImap.Delete()
        	
	Next
